routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

use App\Genre;
use App\Http\Resources\GenreResource;
use App\Http\Resources\SerieResource;
use App\Serie;

Auth::routes();

Route::get('/', 'MainController@index')->name('home');
Route::get('/home', 'MainController@index')->name('home');
Route::resource('episodes', 'EpisodeController');
Route::resource('comments', 'CommentController');

Route::resource('genres', 'GenreController');
Route::resource('series', 'SerieController');

Route::get('modifier_avis_redaction/{id}','SerieController@editAvis')->name("editAvis");
Route::resource('users', 'UserController');

Route::get('/saison/{idSerie}/{idSaison}','SerieController@showSaison')->name('showSaison');

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;

class User extends Authenticatable {
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    function seen() {
        return $this->belongsToMany("App\Episode", 'seen');
    }


    public function commente(){
        return $this->hasMany("App\Comment",'user_id');
    }

    /*public function VuEpisode($idEpisode) {
        $episode=DB::table('seen')->where('episode_id', '=', $idEpisode)->where('user_id', Auth::id())->first();

        if (isset($episode)) {
            return true;
        }

        return false;
    }*/

}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\Models\Jeu;
use Illuminate\Http\Request;
use App\User;
use App\Comment;
use Illuminate\Support\Facades\Hash;

class UserController extends Controller
{

    public function index(){

        $users = User::all();
        return view('users.index',['users'=> $users] );
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */


    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id,Request $request)
    {
        //
        $action = $request->query('action','show');
        $user=User::find($id);
        $duree=0;
        $nbCom=0;
        $nbSerieVue=0;
        $commentaires=[];
        $series=[];

        foreach($user->commente as $com){
            $nbCom++;


        }



        foreach($user->seen as $ep){
            $duree+=$ep->duree;

            if(!in_array($ep->serie,$series)){
                array_push($series,$ep->serie);
                $nbSerieVue++;
            }
        }

        return view('users.show',['users' => $user,'action' =>$action,'duree'=>$duree,'commentaires'=>$commentaires,'nbCom'=>$nbCom,'nbSerieVue'=>$nbSerieVue,'series'=>$series]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $user = User::find($id);
        return view('users.edit', ['user' => $user]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $user = User::find($id);

        $validatedData = $request -> validate([
            'name' => ['required', 'max:191'],
            'email'=> ['required', 'max:191'],
            'password'=>['required','max:191'],
            'avatar'=>['required', 'max:191']
        ]);

        $input = $request->only(['name', 'email', 'password', 'avatar']);
        $user->name = $request->name;
        $user->email = $request -> email;
        $user->password = Hash::make($request['password']);
        $user->avatar = $request->avatar;

        $user->save();

        return redirect()->route('users.show', $user->id);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id,Request $request)
    {
        //

    }
}

resources/views/users/edit.blade.php
@extends('layouts.app')

@section('content')

    <h2 class="titre1">Modification d'un utilisateur</h2>


    @if ($errors->any())
        <div>
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif
    {{--
         formulaire de saisie d'une tâche
         la fonction 'route' utilise un nom de route.
         '@csrf' ajoute un champ caché qui permet de vérifier
           que le formulaire vient du serveur.
         '@method('PUT') précise à Laravel que la requête doit être traitée
          avec une commande PUT du protocole HTTP.
      --}}

    <form action="{{route('users.update',$user->id)}}" method="POST" encrypte="multipart/form-data">
        @csrf
        @method('PUT')
        <div class="text-center" style="margin-top: 2rem">
            <h3>Modification d'un utilisateur</h3>
            <hr class="mt-2 mb-2">
        </div>
        <div>
            {{-- Nom  --}}
            <label for="name"><strong>Nom :</strong></label>
            <input type="varchar" class="form-control" id="name" name="name"
                   value="{{ $user->name}}">
        </div>
        <div>
            {{-- Email --}}
            <label for="email"><strong>Date de sortie : </strong></label>
            <input type="varchar" name="email" id="email"
                   value="{{ $user->email }}">

        </div>
        <div>
            {{-- Password  --}}
            <label for="password"><strong>Mot de passe : </strong></label>
            <input type="varchar" class="form-control" id="password" name="password"
                   value="{{ $user->age_min}}">
        </div>

        <div>
            {{-- Avatar --}}
            <label for="avatar"><strong>Avatar : </strong></label>
            <input type="varchar" class="form-control" id="avatar" name="avatar"
                   value="{{ $user->avatar}}">
        </div>

        <div>
            <button class="btn btn-success" type="submit">Valide</button>
        </div>
    </form>
    <a href="{{route('users.show',$user->id)}}">Retour</a>
@endsection

resources/views/users/index.blade.php
@extends('layouts.app')

@section('content')
    @guest
        <h2 class="titre1">Accès interdit</h2>
        <div class="information-contenu links">
            Désolé, vous n'êtes pas connecté.
            Vous ne pouvez pas voir cette page.
            <br>
            <br>
            <a style="text-decoration: underline;" href="{{route('register')}}">Inscrivez-vous</a>.
            <br>
            <br>
            Vous avez déjà un compte ?
            <a style="text-decoration: underline;" href="{{route('login')}}">Connectez-vous</a>.
        </div>
    @else
        @if(Auth::id()!=$users->id and Auth::user()->administrateur!=true)
            <h2 class="titre1">Accès interdit</h2>
            <div class="information-contenu links">
                Désolé, ceci n'est pas votre profil.
                Vous ne pouvez pas voir cette page.
                <br>
                <br>
                <a style="text-decoration: underline;" href="{{route('users.show',$users->id)}}">Voir votre profil</a>.
                <br>

            </div>
        @else

            <h2 class="titre1">Utilisateurs</h2>

            <div class="information-contenu">
            @if(!empty($users))
                <ul class="liste links">

                    @foreach($users as $user)
                        <!--<li>auth::user
                        </li>-->

                        <a href="{{route('users.show',$user->id)}}">{{$user->name}}</a>
                        <br>
                    @endforeach
                </ul>
            @else
                <h3>Il n'y a pas d'utilisateur </h3>
            @endif
            </div>
        @endif
    @endguest

@endsection

resources/views/users/show.blade.php
@extends('layouts.app')

@section('content')
    @guest
        <h2 class="titre1">Accès interdit</h2>
        <div class="information-contenu links">
            Désolé, vous n'êtes pas connecté.
            Vous ne pouvez pas voir cette page.
            <br>
            <br>
            <a style="text-decoration: underline;" href="{{route('register')}}">Inscrivez-vous</a>.
            <br>
            <br>
            Vous avez déjà un compte ?
            <a style="text-decoration: underline;" href="{{route('login')}}">Connectez-vous</a>.
        </div>
    @else
        @if(Auth::id()!=$users->id and Auth::user()->administrateur!=true)
            <h2 class="titre1">Accès interdit</h2>
            <div class="information-contenu links">
                Désolé, ceci n'est pas votre profil.
                Vous ne pouvez pas voir cette page.
                <br>
                <br>
                <a style="text-decoration: underline;" href="{{route('users.show',$users->id)}}">Voir votre profil</a>.
                <br>

                </div>
        @else
            <div class="information-contenu links">
                {{-- nom  --}}
                <h2 class="titre1">{{$users->name}}</h2>
                <img src="{{$users->avatar}}" alt="Avatar de l'utilisateur">
                <br>
                <p><strong>Utilisateur : </strong>{{$users->name}}</p>
                <p><strong>Adresse mail : </strong>{{$users->email}}</p>

                <br>

                <a style="text-decoration: underline;" href="{{route('users.edit',$users->id)}}">Modifier le compte</a>
                <a style="text-decoration: underline;" href="{{$users->id}}?action=delete">Supprimer le compte</a>


                <h2>Statistique : </h2>
                <p>
                    Durée passée à regarder des séries:<b>{{$duree}} min</b>
                </p>
                <p>
                    Nombre de series regardées:<b>{{$nbSerieVue}}</b>
                    <br>
                </p>

                <h2>Series vues:</h2>
                <div class="liste">
                <ul class="series-grid">

                    @foreach($series as $ser)
                        <li class="links">
                            <a href="{{route('series.show',$ser->id)}}">
                                <img src="{{url($ser->urlImage)}}" alt="image de la série">
                                <br>
                                {{$ser->nom}}
                            </a>
                        </li>
                    @endforeach
                </ul>
                </div>

                <br>

                <p>Nombre de commentaires:<b>{{$nbCom}}</b></p>
                <h2>Commentaires postés:</h2>

                <div class="liste">
                    <ul class="series-grid">
                        @foreach($users->commente as $com)
                            <li class="links">
                                <b>{{$com->serie->nom}}</b>
                                <br>
                                <b>"</b>
                                {{$com->content}}
                                <b>"</b>
                            </li>
                        @endforeach
                    </ul>
                </div>

            </div>
            @endif
    @endguest
@endsection